package orderprocessing;



import java.awt.*;
import fit.Fixture;
import junit.extensions.abbot.*;
import abbot.script.ComponentReference;
import abbot.tester.ComponentTester;
import abbot.tester.ChoiceTester;


public class CustomerEntryGuiFixture extends Fixture // from Fit
{
	static
	{	
		CustomerEntry cust = new CustomerEntry(); // The GUI to be tested
	}
	TextField customerNumber = null; // References to objects in the GUI
	TextField customerName = null;
	TextField billingName = null;
	TextField billingStreet = null;
	TextField billingCity = null;
	TextField billingState = null;
	TextField billingZip = null;
	TextField shippingName = null;
	TextField shippingStreet = null;
	TextField shippingCity = null;
	TextField shippingState = null;
	TextField shippingZip = null;
	Choice billingTerms = null; 
	Button sameAddress = null;
	Button accept = null;
	Button writeDB = null;
	Button reset = null;
	ComponentTester testBasic = null;
	ChoiceTester testChoice = null;
	
	public CustomerEntryGuiFixture() throws Exception
	{	GuiTest test = new GuiTest("Customer Entry");
		test.setUp();
	}
	
	class GuiTest extends ComponentTestFixture // From Abbot's JUnit extensions
	{	public GuiTest(String name)
		{	super(name);
		}
		
		public void setUp() throws Exception
		{
			
			ComponentReference ref = new ComponentReference("customerNumber", TextField.class,"CEcustomerNumber", "CNUM");
			customerNumber = (TextField)getFinder().findComponent(ref);
			testBasic = new ComponentTester();

			ref = new ComponentReference("customerName", TextField.class,"CEcustomerName", "CNAME");
			customerName = (TextField)getFinder().findComponent(ref);			
			ref = new ComponentReference("billingName", TextField.class,"CEbillingName","BNAME");
			billingName = (TextField)getFinder().findComponent(ref);			
			ref = new ComponentReference("billingStreet", TextField.class,"CEbillingStreet", "BSTREET");
			billingStreet = (TextField)getFinder().findComponent(ref);
			ref = new ComponentReference("billingCity", TextField.class,"CEbillingCity","BCITY");
			billingCity = (TextField)getFinder().findComponent(ref);						
			ref = new ComponentReference("billingState", TextField.class,"CEbillingState","BSTATE");
			billingState = (TextField)getFinder().findComponent(ref);			
			ref = new ComponentReference("billingZip", TextField.class,"CEbillingZip","BZIP");
			billingZip = (TextField)getFinder().findComponent(ref);			
			ref = new ComponentReference("shippingName", TextField.class,"CEshippingName","SNAME");
			shippingName = (TextField)getFinder().findComponent(ref);			
			ref = new ComponentReference("shippingStreet", TextField.class,"CEshippingStreet","SSTREET");
			shippingStreet = (TextField)getFinder().findComponent(ref);
			ref = new ComponentReference("shippingCity", TextField.class,"CEshippingCity","SCITY");
			shippingCity = (TextField)getFinder().findComponent(ref);
			ref = new ComponentReference("shippingState", TextField.class,"CEshippingState","SSTATE");
			shippingState = (TextField)getFinder().findComponent(ref);
			ref = new ComponentReference("shippingZip", TextField.class,"CEshippingZip","SZIP");
			shippingZip = (TextField)getFinder().findComponent(ref);
			ref = new ComponentReference("billingTerms", Choice.class,"CEbillingTerms","BTERMS");
			billingTerms = (Choice)getFinder().findComponent(ref);
			ref = new ComponentReference("sameAddress", Button.class, "CEsameAddress", "SADDRESS");
			sameAddress = (Button)getFinder().findComponent(ref);
			ref = new ComponentReference("accept", Button.class, "CEaccept", "ACCEPT");
			accept = (Button)getFinder().findComponent(ref);
			ref = new ComponentReference("writeDB", Button.class, "CEwriteDB", "WRITEDB");
			writeDB = (Button)getFinder().findComponent(ref);
			ref = new ComponentReference("reset", Button.class, "CEreset", "RESET");
			reset = (Button)getFinder().findComponent(ref);
			testChoice = new ChoiceTester();												
						
		}
	}

	private int delay = 0;
	
	private void click(Component comp)
	{	testBasic.actionClick(comp);	// robot clicks the button, firing action events
		testBasic.actionDelay(delay);
	}

	private void enter(TextField field,String s)
	{	click(field);
		field.setText(s);
		//testBasic.actionDelay(delay);
	}
	
	// A pseudo key so that the customer can set the delay for a test.
	public void setDelay(int d)
	{	delay = d;
	}
	
	// A pseudo key so that the customer can open the db or not for a test.
	public void openDB()
	{	OrderProcessor.open(OrderProcessor.databaseName());
	}

	public void enterKey()
	{	testBasic.actionKeyStroke("VK_ENTER");
		testBasic.actionDelay(delay);
	}

	public void customerNumber(String s)
	{	enter(customerNumber,s);
		testBasic.actionDelay(delay);
	}
	public String customerNumber()
	{	
		testBasic.actionDelay(delay);
		return customerNumber.getText();
	}
	public void customerName(String s)
	{	enter(customerName,s);
		testBasic.actionDelay(delay);
	}
	public String customerName()
	{	testBasic.actionDelay(delay);
		return customerName.getText();
	}

	public void billingName(String s)
	{	enter(billingName,s);
		testBasic.actionDelay(delay);
	}
	public String billingName()
	{	testBasic.actionDelay(delay);
		return billingName.getText();
	}

	public void billingStreet(String s)
	{	enter(billingStreet,s);
		testBasic.actionDelay(delay);
	}
	public String billingStreet()
	{	testBasic.actionDelay(delay);
		return billingStreet.getText();
	}

	public void billingCity(String s)
	{	enter(billingCity,s);
		testBasic.actionDelay(delay);
	}
	public String billingCity()
	{	testBasic.actionDelay(delay);
		return billingCity.getText();
	}

	public void billingState(String s)
	{	enter(billingState,s);
		testBasic.actionDelay(delay);
	}
	public String billingState()
	{	testBasic.actionDelay(delay);
		return billingState.getText();
	}

	public void billingZip(String s)
	{	enter(billingZip,s);
		testBasic.actionDelay(delay);
	}
	public String billlingZip()
	{	testBasic.actionDelay(delay);
		return billingZip.getText();
	}

	public void shippingName(String s)
	{	enter(shippingName,s);
		testBasic.actionDelay(delay);
	}
	public String shippingName()
	{	testBasic.actionDelay(delay);
		return shippingName.getText();
	}

	public void shippingStreet(String s)
	{	enter(shippingStreet,s);
		testBasic.actionDelay(delay);
	}
	public String shippingStreet()
	{	testBasic.actionDelay(delay);
		return shippingStreet.getText();
	}

	public void shippingCity(String s)
	{	enter(shippingCity,s);
		testBasic.actionDelay(delay);
	}
	public String shippingCity() throws Exception
	{	testBasic.actionDelay(delay);
		return shippingCity.getText();
	}

	public void shippingState(String s)
	{	enter(shippingState,s);
		testBasic.actionDelay(delay);
	}
	public String shippingState() throws Exception
	{	testBasic.actionDelay(delay);
		return shippingState.getText();
	}

	public void shippingZip(String s)
	{	enter(shippingZip,s);
		testBasic.actionDelay(delay);
	}
	public String shippingZip() throws Exception
	{	testBasic.actionDelay(delay);
		return shippingZip.getText();
	}

	public String billingTerms()
	{	testBasic.actionDelay(delay);
		return billingTerms.getSelectedItem();
	}
	
	public void billingTerms(String s)
	{	testChoice.actionSelectItem(billingTerms, s);
		testBasic.actionDelay(delay);
	}
	
	public void sameAddress()   
	{	click(sameAddress);
	}
	public void accept()
	{	click(accept);
	}
	public void writeDB()
	{	click(writeDB);
	}
	public void reset()
	{	click(reset);
	}
}
