/*
 * Created on Nov 8, 2003
 *
 */
package orderprocessing;

import java.awt.*;
//import java.awt.event.*;
import fit.Fixture;
import junit.extensions.abbot.*;
import abbot.script.ComponentReference;
import abbot.tester.ComponentTester;
import abbot.tester.ChoiceTester;

/**
 * @author jbergin
 *
 */
public class OrderEntryGuiFixture extends Fixture // from fit
{
	static
	{	//OrderProcessor.open(OrderProcessor.databaseName());
		OrderEntry oe = new OrderEntry();		
	}
	// define references to the gui's testable components
	Button getCustomerInfo = null;
	TextField customerNumber = null; // set
	TextField customerName = null;  // get
	TextArea customerAddress = null; // get
	TextArea shippingAddress = null; // get set
	Choice billingTerms = null; // get set
	TextField orderDateField = null; // get set
	TextField shipDateField = null; // get set
	TextField cancelDateField = null; // get set
	TextField itemNumberField = null; // get set
	TextField quantityField = null; // set
	TextField priceField = null; // set
	TextField descriptionField = null; // set
	Button accept = null;
	Button enter = null;
	// define the robots that will manipulate the above. These can generate
	// events for your components, whereas the direct manipulation of 
	// the components does not. 
	ComponentTester testBasic = null; // for buttons, text fields and areas
	ChoiceTester testChoice = null; // for the choice component
		 
	public OrderEntryGuiFixture() throws Exception
	{	GuiTest test = new GuiTest("Order Entry");
		test.setUp(); // create the components and robots
	}
	
	class GuiTest extends ComponentTestFixture // from Abbot
	{	public GuiTest(String name)
		{	super(name);
		}
		
		// This sets values into both our component references and
		// the robots. This is why we want Abbot. 
		public void setUp() throws Exception
		{
			ComponentReference ref = new ComponentReference("getCustomerInfo", Button.class, "OEgetCustomerInfo", "CI");
			getCustomerInfo = (Button)getFinder().findComponent(ref);
			testBasic = new ComponentTester();
			
			ref = new ComponentReference("accept", Button.class, "OEaccept", "A");
			accept = (Button)getFinder().findComponent(ref);
			
			ref = new ComponentReference("enter", Button.class, "OEenter", "E");
			enter = (Button)getFinder().findComponent(ref);
			
			ref = new ComponentReference("orderDateField",TextField.class, "OEorderDateField","ODF");
			orderDateField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("shipDateField",TextField.class, "OEshipDateField","SDF");
			shipDateField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("cancelDateField",TextField.class, "OEcancelDateField","CDF");
			cancelDateField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("itemNumberField",TextField.class, "OEitemNumberField","INu");
			itemNumberField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("quantityField",TextField.class, "OEquantityField","QF");
			quantityField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("priceField",TextField.class, "OEpriceField","PF");
			priceField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("descriptionField",TextField.class, "OEdescriptionField","DF");
			descriptionField = (TextField)getFinder().findComponent(ref);
			
			ref = new ComponentReference("customerNumber",TextField.class, "OEcustomerNumber","CNu");
			customerNumber = (TextField)getFinder().findComponent(ref);

			ref = new ComponentReference("customerName",TextField.class, "OEcustomerName","CNa");
			customerName = (TextField)getFinder().findComponent(ref);

			ref = new ComponentReference("customerAddress",TextArea.class, "OEcustomerAddress","CA");
			customerAddress = (TextArea)getFinder().findComponent(ref);

			ref = new ComponentReference("shippingAddress",TextArea.class, "OEshippingAddress","SA");
			shippingAddress = (TextArea)getFinder().findComponent(ref);

			ref = new ComponentReference("billingTerms", Choice.class, "OEbillingTerms", "BT");
			billingTerms = (Choice)getFinder().findComponent(ref);
			testChoice = new ChoiceTester();//(ChoiceTester)ChoiceTester.getTester(billingTerms);
		}
		
	}
	
	private int delay = 0;

	private void click(Component comp)
	{	testBasic.actionClick(comp);
		testBasic.actionDelay(delay);
	}
	
	private void enter(TextField field,String s)
	{	click(field);
		field.setText(s);
		//testBasic.actionDelay(delay);
	}
	
	// A pseudo key so that the customer can set the delay for a test.
	public void setDelay(int d)
	{	delay = d;
	}
	
	// A pseudo key so that the customer can open the db or not for a test.
	public void openDB()
	{	OrderProcessor.open(OrderProcessor.databaseName());
		testBasic.actionDelay(delay);
	}

	public void customerInfoButton()
	{	click(getCustomerInfo);
	}
	
	public void customerNumber(String s)
	{	enter(customerNumber,s);
	}
	
	public String customerNumber()
	{	return customerNumber.getText();
	}
	
	// This is how to press the enter key in a field.
	// Need to give focus to the field you want the action event sent through.
	public void enterKey()
	{	testBasic.actionKeyStroke("VK_ENTER");
		testBasic.actionDelay(delay);
	}
	
	public String customerName()
	{	testBasic.actionDelay(delay);
		return customerName.getText();
	}
	
	public String billingTerms()
	{	return billingTerms.getSelectedItem();
	}
	
	public void billingTerms(String s)
	{	testChoice.actionSelectItem(billingTerms, s);
	}
	
	private String canonical(String s)
	{	return s.replace('\n',','); // more required here
	}
	private String deCanonical(String s)
	{	return s.replace(',','\n');
	}
	
	// TextAreas are hard to extract info from. 
	// Newline problems, space problems (html only shows 1)
	public String billingAddress()
	{	return canonical(customerAddress.getText());
	}
	
//	public void billingAddress(String s)
//	{	customerAddress.setText(deCanonical(s));
//	}

	public String shippingAddress()
	{	return canonical(shippingAddress.getText());
	}
	
	public void shippingAddress(String s)
	{	shippingAddress.setText(deCanonical(s));
	}
	
	// getters and setters
	public String orderDate()
	{	return orderDateField.getText();
	}
	public void orderDate(String s)
	{	orderDateField.setText(s);
	}

	public String shipDate()
	{	return shipDateField.getText();
	}
	public void shipDate(String s)
	{	shipDateField.setText(s);
	}

	public String cancelDate()
	{	return cancelDateField.getText();
	}
	public void cancelDate(String s)
	{	cancelDateField.setText(s);
	}

	// setters only here. May change.
	public void itemNumber(String s)
	{	itemNumberField.setText(s);
	}

	public void quantity(String s)
	{	quantityField.setText(s);
	}

	public String quantity()
	{	return quantityField.getText();
	}
//	public void price(String s)
//	{	priceField.setText(s);
//	}
//
//	public void description(String s)
//	{	descriptionField.setText(s);
//	}

	public String description()
	{	return descriptionField.getText();
	}
	public String price()
	{	return priceField.getText();
	}
}
