/*
 * Created on Nov 8, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package orderprocessing;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.framework.Test;
//import java.io.IOException;
import java.util.Iterator;
import java.util.Hashtable;


/**
 * @author gbaker
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ProductTest extends TestCase
{
  public ProductTest(String s) 
  {
    super(s);
  } // Always required. Omitted from documentation.

  private Product p1 = null;
  private String p1Key = "";
  
  public void setUp() 
  {
    try 
    {
      p1 = Product.generateProduct(9.0d, "Widget");
      p1Key = p1.key();
    }
    catch (Exception e) 
    {
      fail("Unable to generate Product" + e.getMessage()); // this should not have happened
    }
  }

  /** This will test the Product to make sure that there is a product id, a price and a description entered in the object.  GWB 11/08/03	 *
   *
   *
   **/
  public void testProductDataById() 
  {
		Product p2;

	   	p2 = Product.get(p1Key);
	  	assertEquals("ProductDataByID - ID is missing.", p1Key, p2.key());
	  	assertEquals("ProductDataByID - Product Price is incorrect.",
				 9.0d ,p2.price(), 0.001);
	  	assertEquals("ProductDataByID - Product Description is incorrect.",
				   "Widget", p2.description());
   }

  public void testPriceRange() 
  {
    try 
    {
      Product productTemp = Product.generateProduct(2.1, "Test Product");
      assertTrue("Price out of range",
                 (productTemp.price() > 0 &&
                  productTemp.price() < 1000));
    }
    catch (Exception e) 
    {
      System.out.println(e.getMessage());
    }
    try 
    {
      Product productTemp = Product.generateProduct(0.009, "descprition");
      fail("Product generated with price too low"); // this should not have happened
    }
    catch (Exception e) 
    {
      // don't need to do anything, Exception is expected
    }
    try 
    {
      Product productTemp = Product.generateProduct(1000, "descprition");
      fail("Product generated with price too high"); // this should not have happened
    }
    catch (Exception e) {
      // don't need to do anything, Exception is expected
    }
  }

  /* @TODO Team 3
   * Verify that the generated product IDs are unique and consecutive.
   */
  public void testConsecutiveID() 
  {
    try 
    {
      Product productTemp = Product.generateProduct(1.0, "Test Product");
      String oldID = productTemp.key(); // get number part from Product ID
      for (int i = 1; i < 10; ++i) { // create new product and check if the new Product IDs are consecutive
        productTemp = Product.generateProduct(i, new String("Test Product " + Integer.toString(i)));
        String nextID = productTemp.key(); // get number part from new Product ID
        assertEquals("Product ID not consecutive", nextID, "P" + (Integer.parseInt(oldID.substring(1)) + i)); // make usre numbers are consecutive
      }
    }
    catch (Exception e) 
    {
      fail("Exception has been thrown incorrectly:" + e.getMessage());
    }
  }

  /** This will test the Product to make sure that there is a product id, a price and a description entered in the object.  GWB 11/08/03
   *
   *
   */
  public void testProductDescription() 
  {
    try 
    {
      Product productTemp = Product.generateProduct(1.0, null);
      fail("Product generated with no Product Description"); // this should not have happened
    }
    catch (Exception e) 
    {
      // don't need to do anything, Exception is expected
    }
  }

  /**
   * This method will test whether newely created records are put into the database or not.
   * @return
   */
  public void testDBAccesss() 
  {
    OrderProcessor.open(OrderProcessor.databaseName());
    Hashtable oldProducts = new Hashtable();

    // record every product item read from the Database
    Iterator it = Product.keys();
    while (it.hasNext())
    {
         String pID = (String) it.next();
        Product pd = Product.get(pID);
        oldProducts.put(pd.key(), pd);
     }

    // Add new products into product list
    Product productTemp;
    for (int i = 1; i < 10; ++i)
    { // create new products
      try
      {
        productTemp = Product.generateProduct(i, new String("Test Product " + Integer.toString(i)));
        oldProducts.put(productTemp.key(), productTemp);
      }
      catch (Exception e)
      {
        System.out.println("Fail to create new product");
      }
    }

    // store all products into database file
    System.out.println(OrderProcessor.databaseName());
    OrderProcessor.close(OrderProcessor.databaseName());

    // read all data from database file
    OrderProcessor.open(OrderProcessor.databaseName());
 	 // iterate through Product list and make sure that it's the same as old Product list
      Iterator itor = Product.keys();
      for (int i=1; itor.hasNext(); i++)
      {

        String pID = (String) itor.next();
        Product pd = Product.get(pID);
        Product oldItem = (Product) oldProducts.get(pd.key());
        assertEquals("Product stored incorrectly to DB file", oldItem.toString(), pd.toString());
        System.out.println(Integer.toString(i) + ": " + pd.toString());
      }
      Product tmpProd = Product.get("P5001");
   }

  public static Test suite() 
  {
    return new TestSuite(ProductTest.class);
  }

  public static void main(String[] args) 
  { 
    junit.textui.TestRunner.run(suite());
  }
}


